//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#include <tigcclib.h>

//-----------------------------------------------------------------------------

typedef struct
{
	int a,b,q,r;
	int u,v;
}
TDivision;

//-----------------------------------------------------------------------------

// Main Function
void _main(void)
{
	char buffer[50];
	
	TDivision DIVS[128];
	int x,y;
	
	clrscr();
	FontSetSys(0);
	printf("BezMeth 1.1 \n");
	printf("Programmed by Olivier Sangala \n");
	printf("http://olivier.sangala.free.fr \n");
	printf("olivier_sangala@hotmail.com \n");
	FontSetSys(1);
	ngetchx();
	
	FontSetSys(0);
	
	lbl_start:
	clrscr();
	
	
	printf("x=");
	gets(buffer);
	x=atoi(buffer);
	printf("\n");
	
	printf("y=");
	gets(buffer);
	y=atoi(buffer);
	printf("\n");
	
	printf("\n");
	
	if (x<=0 || y<=0 || x<y)
	{
		printf("Error : x<=0 or y<=0 or x<y \n");
		ngetchx();
		goto lbl_start;
	}
	
	// STEP #1 : DIVISIONS
	
	int a=x;
	int b=y;
	int q=0;
	int r=0;
	
	int c=0;
	
	for (c=0;;c++)
	{
		div_t dt=div(a,b);
		q=dt.quot;
		r=dt.rem;
		
		// STORE DIVISIONS
		DIVS[c].a=a;
		DIVS[c].b=b;
		DIVS[c].q=q;
		DIVS[c].r=r;
		
		printf("%d = %d * %d + %d \n",a,b,q,r);
		
		if (r==0)
		break;
		
		a=b;
		b=r;
	}
	
	printf("\n");
	ngetchx();
	
	// STEP #2 : PGCD
	
	int pgcd=0;
	
	
	if (c==0)
	{
		printf("Error : x multiple of y \n");
		ngetchx();
		goto lbl_start;
	}
	else
	{
		pgcd=DIVS[c-1].r;
		printf("pgcd(%d,%d) = %d \n\n",x,y,pgcd);
		ngetchx();
	}
	
	// STEP #3 : COUPLES
	
	int i=0;
	
	for (i=0;;i++)
	{
		
		if (i==0)
		{
			DIVS[i].u=1;
			DIVS[i].v=-DIVS[i].q;
		}
		else if (i==1)
		{
			DIVS[i].u=0-(DIVS[i-1].u*DIVS[i].q);
			DIVS[i].v=1-(DIVS[i-1].v*DIVS[i].q);
		}
		else
		{
			DIVS[i].u=DIVS[i-2].u-(DIVS[i-1].u*DIVS[i].q);
			DIVS[i].v=DIVS[i-2].v-(DIVS[i-1].v*DIVS[i].q);
		}
		
		printf("%d = %d * %d + %d * %d \n",DIVS[i].r,DIVS[i].u,x,DIVS[i].v,y);
		
		if (DIVS[i].r==pgcd)
		break;
		
	}
	
	printf("\n");
	ngetchx();
	
	// STEP #4 : SOLUTION
	
	printf("Solution : (%d,%d) \n\n",DIVS[i].u,DIVS[i].v);
	ngetchx();
	
	printf("[ENTER] : Continue \n");
	printf("[ESC] : Exit");
	
	int key;
	while ((key=ngetchx())!=KEY_ENTER && key!=KEY_ESC);
	
	if (key==KEY_ENTER)
	goto lbl_start;
	
}
